package cn.ibizlab.assetmanagement.core.asset.service;

import java.io.Serializable;
import java.sql.Timestamp;
import java.util.ArrayList;
import java.util.List;
import java.util.Map;
import java.util.HashMap;
import java.util.Collection;
import java.math.BigInteger;

import org.springframework.data.domain.Page;
import org.springframework.data.domain.Pageable;
import com.alibaba.fastjson.JSONObject;
import org.springframework.cache.annotation.CacheEvict;

import cn.ibizlab.assetmanagement.core.asset.domain.EAMAssetStateModelLine;
import cn.ibizlab.assetmanagement.core.asset.filter.EAMAssetStateModelLineSearchContext;


import com.baomidou.mybatisplus.extension.service.IService;

/**
 * 实体[EAMAssetStateModelLine] 服务对象接口
 */
public interface IEAMAssetStateModelLineService extends IService<EAMAssetStateModelLine>{

    boolean create(EAMAssetStateModelLine et) ;
    void createBatch(List<EAMAssetStateModelLine> list) ;
    boolean update(EAMAssetStateModelLine et) ;
    void updateBatch(List<EAMAssetStateModelLine> list) ;
    boolean remove(String key) ;
    void removeBatch(Collection<String> idList) ;
    EAMAssetStateModelLine get(String key) ;
    EAMAssetStateModelLine getDraft(EAMAssetStateModelLine et) ;
    boolean checkKey(EAMAssetStateModelLine et) ;
    boolean save(EAMAssetStateModelLine et) ;
    void saveBatch(List<EAMAssetStateModelLine> list) ;
    Page<EAMAssetStateModelLine> searchDefault(EAMAssetStateModelLineSearchContext context) ;
    List<EAMAssetStateModelLine> selectByEamassetstatemodelid(String eamassetstatemodelid) ;
    void removeByEamassetstatemodelid(String eamassetstatemodelid) ;
    List<EAMAssetStateModelLine> selectByEamassetstateid(String eamassetstateid) ;
    void removeByEamassetstateid(String eamassetstateid) ;
    /**
     *自定义查询SQL
     * @param sql  select * from table where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return select * from table where id = '1'
     */
    List<JSONObject> select(String sql, Map param);
    /**
     *自定义SQL
     * @param sql  update table  set name ='test' where id =#{et.param}
     * @param param 参数列表  param.put("param","1");
     * @return     update table  set name ='test' where id = '1'
     */
    boolean execute(String sql, Map param);

    List<EAMAssetStateModelLine> getEamassetstatemodellineByIds(List<String> ids) ;
    List<EAMAssetStateModelLine> getEamassetstatemodellineByEntities(List<EAMAssetStateModelLine> entities) ;
}


